/*
 * Copyright (c) Tobias Hopp, 2022.
 * This program is copyright protected.
 * Copying, distributing or using source code is prohibited.
 * Any distribution or illegal copying will be prosecuted.
 *
 * You may not use this sourcecode.
 *
 */

import {contextBridge, ipcRenderer} from "electron";


contextBridge.exposeInMainWorld('trycrypt', {
    getKey: () : Promise<string[]> => {
        return ipcRenderer.invoke("getKey");
    },
    setKey: (key: string, iv: string) => {
        ipcRenderer.send("setKey", key, iv);
    },
    generateKey: () : Promise<string[]> => {
        return ipcRenderer.invoke("generateKey");
    },
    encrypt: (text: string) : Promise<string> => {
        return ipcRenderer.invoke("encrypt", text);
    },
    decrypt: (text: string) : Promise<string> => {
        return ipcRenderer.invoke("decrypt", text);
    }
})