let key: string, iv: string;
let keyField: HTMLInputElement;
let ivField: HTMLInputElement;
let keySave: HTMLButtonElement;
let keyShow: HTMLButtonElement;
let keyGenerate: HTMLButtonElement;
let decryptBtn: HTMLButtonElement;
let encryptBtn: HTMLButtonElement;
let userTB: HTMLTextAreaElement;
let systemTB: HTMLTextAreaElement;

document.addEventListener("DOMContentLoaded", async () => {
    // Loaded
    keyField = document.getElementById("keyField") as HTMLInputElement;
    ivField = document.getElementById("ivField") as HTMLInputElement;
    keySave = document.getElementById("keySave") as HTMLButtonElement;
    keyShow = document.getElementById("keyRefresh") as HTMLButtonElement;
    keyGenerate = document.getElementById("generateRandom") as HTMLButtonElement;
    userTB = document.getElementById("userTB") as HTMLTextAreaElement;
    systemTB = document.getElementById("systemTB") as HTMLTextAreaElement;
    encryptBtn = document.getElementById("btnEncrypt") as HTMLButtonElement;
    decryptBtn = document.getElementById("btnDecrypt") as HTMLButtonElement;

    systemTB.onclick = () => {
        const range = document.createRange();
        range.selectNodeContents(systemTB);
        const selection = window.getSelection();
        selection.removeAllRanges();
        selection.addRange(range);
        navigator.clipboard.writeText(systemTB.value);

    }


    // @ts-ignore
    [key, iv] = await window.trycrypt.getKey();

    if (key)
        keyField.value = key;
    if (iv)
        ivField.value = iv;

    keySave.onclick = () => onKeySave();
    keyShow.onmousedown = () => {
        keyField.type = "text";
        ivField.type = "text";
    }
    keyShow.onmouseup = () => {
        keyField.type = "password";
        ivField.type = "password";
    }

    encryptBtn.onclick = () => encrypt();
    decryptBtn.onclick = () => decrypt();
    keyGenerate.onclick = () => generateRandom();
});

function onKeySave() {
    key = keyField.value;
    iv = ivField.value;
    // @ts-ignore
    window.trycrypt.setKey(key, iv);
    keySave.style.backgroundColor = "green";
    setTimeout(() => keySave.style.backgroundColor = "", 1000);
}

async function generateRandom() {
    //@ts-ignore
    let [gen_key, gen_iv] = await window.trycrypt.generateKey();
    key = gen_key;
    iv = gen_iv;

    keyField.value = key;
    ivField.value = iv;

    keyField.type = "text";
    ivField.type = "text";
    setTimeout( () => {
        keyField.type = "password";
        ivField.type = "password";
    }, 3000 );
}

async function encrypt() {
    let text = userTB.value;

    // @ts-ignore
    systemTB.value = await window.trycrypt.encrypt(text);
}

async function decrypt() {
    let text = userTB.value;

    // @ts-ignore
    systemTB.value = await window.trycrypt.decrypt(text);
}

